﻿!mod$ v1 sum:28e2c59dad977eab
!need$ 8f2bb99b9e3c04c9 n dftd4_damping
!need$ ae78003ee30bd742 n mctc_env
!need$ 880c3f35e6e2ea39 n mctc_io
!need$ 2199023823c61ebd n dftd4_damping_atm
!need$ e1872f1eb79bc61b n dftd4_data
module dftd4_damping_rational
use dftd4_damping,only:damping_param
use dftd4_damping_atm,only:get_atm_dispersion
use dftd4_data,only:get_r4r2_val
use mctc_env,only:wp
use mctc_io,only:structure_type
private::damping_param
private::get_atm_dispersion
private::get_r4r2_val
private::wp
private::structure_type
type,extends(damping_param)::rational_damping_param
real(8)::s6=1._8
real(8)::s8
real(8)::s9=1._8
real(8)::a1
real(8)::a2
real(8)::alp=1.6e1_8
contains
procedure::get_dispersion2
procedure::get_dispersion3
procedure::get_pairwise_dispersion2
procedure::get_pairwise_dispersion3
end type
private::get_dispersion2
private::get_dispersion_energy
private::get_dispersion_derivs
private::get_dispersion3
private::get_pairwise_dispersion2
private::get_pairwise_dispersion3
private::triple_scale
contains
subroutine get_dispersion2(self,mol,trans,cutoff,r4r2,c6,dc6dcn,dc6dq,energy,dedcn,dedq,gradient,sigma)
class(rational_damping_param),intent(in)::self
class(structure_type),intent(in)::mol
real(8),intent(in)::trans(:,:)
real(8),intent(in)::cutoff
real(8),intent(in)::r4r2(:)
real(8),intent(in)::c6(:,:)
real(8),intent(in),optional::dc6dcn(:,:)
real(8),intent(in),optional::dc6dq(:,:)
real(8),intent(inout)::energy(:)
real(8),intent(inout),optional::dedcn(:)
real(8),intent(inout),optional::dedq(:)
real(8),intent(inout),optional::gradient(:,:)
real(8),intent(inout),optional::sigma(:,:)
end
subroutine get_dispersion_energy(self,mol,trans,cutoff,r4r2,c6,energy)
class(rational_damping_param),intent(in)::self
class(structure_type),intent(in)::mol
real(8),intent(in)::trans(:,:)
real(8),intent(in)::cutoff
real(8),intent(in)::r4r2(:)
real(8),intent(in)::c6(:,:)
real(8),intent(inout)::energy(:)
end
subroutine get_dispersion_derivs(self,mol,trans,cutoff,r4r2,c6,dc6dcn,dc6dq,energy,dedcn,dedq,gradient,sigma)
class(rational_damping_param),intent(in)::self
class(structure_type),intent(in)::mol
real(8),intent(in)::trans(:,:)
real(8),intent(in)::cutoff
real(8),intent(in)::r4r2(:)
real(8),intent(in)::c6(:,:)
real(8),intent(in)::dc6dcn(:,:)
real(8),intent(in)::dc6dq(:,:)
real(8),intent(inout)::energy(:)
real(8),intent(inout)::dedcn(:)
real(8),intent(inout)::dedq(:)
real(8),intent(inout)::gradient(:,:)
real(8),intent(inout)::sigma(:,:)
end
subroutine get_dispersion3(self,mol,trans,cutoff,r4r2,c6,dc6dcn,dc6dq,energy,dedcn,dedq,gradient,sigma)
class(rational_damping_param),intent(in)::self
class(structure_type),intent(in)::mol
real(8),intent(in)::trans(:,:)
real(8),intent(in)::cutoff
real(8),intent(in)::r4r2(:)
real(8),intent(in)::c6(:,:)
real(8),intent(in),optional::dc6dcn(:,:)
real(8),intent(in),optional::dc6dq(:,:)
real(8),intent(inout)::energy(:)
real(8),intent(inout),optional::dedcn(:)
real(8),intent(inout),optional::dedq(:)
real(8),intent(inout),optional::gradient(:,:)
real(8),intent(inout),optional::sigma(:,:)
end
subroutine get_pairwise_dispersion2(self,mol,trans,cutoff,r4r2,c6,energy)
class(rational_damping_param),intent(in)::self
class(structure_type),intent(in)::mol
real(8),intent(in)::trans(:,:)
real(8),intent(in)::cutoff
real(8),intent(in)::r4r2(:)
real(8),intent(in)::c6(:,:)
real(8),intent(inout)::energy(:,:)
end
subroutine get_pairwise_dispersion3(self,mol,trans,cutoff,r4r2,c6,energy)
class(rational_damping_param),intent(in)::self
class(structure_type),intent(in)::mol
real(8),intent(in)::trans(:,:)
real(8),intent(in)::cutoff
real(8),intent(in)::r4r2(:)
real(8),intent(in)::c6(:,:)
real(8),intent(inout)::energy(:,:)
end
elemental function triple_scale(ii,jj,kk) result(triple)
integer(4),intent(in)::ii
integer(4),intent(in)::jj
integer(4),intent(in)::kk
real(8)::triple
end
end
